﻿* Encoding: UTF-8.
*Marginal homogeneity
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_MHTESTS*/vers1***************************************************************************.
define !KO_mhtests(vars1= !charend('/') /vars2= !charend('/') /values= !charend('/') /level= !charend('/')
                  /print= !charend('/') /save= !charend('/'))
!let !ok= 1
!let !vrs2= !vars2
!do !w !in (!vars1)
 !if (!vrs2=!null) !then !let !ok= 0 !break
 !else !let !vrs2= !tail(!vrs2)
 !ifend
!doend
!if (!vrs2<>!null) !then !let !ok= 0 !ifend
!if (!not !ok) !then
-echo ''.
-echo '>ERROR. Списки VARS1 и VARS2 разной длины.'.
!ifend
!if (!values=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Не задано VALUES.'.
!else !if (!values<>'AUTO' !and !tail(!values)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VALUES должно содержать более одного значения.'.
!ifend !ifend
!if (!ok) !then
-set mxloops 10000.
-matrix.
 !if (!values<>'AUTO') !then !let !vals= !null
  !do !w !in (!values) !let !vals= !conc(!vals,',',!w) !doend
  !let !vals= !tail(!vals)
- comp vals= {!vals}.
 !ifend
 !if (!level='INT') !then
- print /title '"MeanDif" = Mean Difference: Mean(V2)-Mean(V1)"'.
 !else !if (!level='ORD') !then
- print /title '"StochDif" = Stochastic Difference: Pr(V2>V1)-Pr(V1>V2)"'.
 !ifend !ifend
 !if (!save='YES') !then
- comp sav= make(1,6,0).
 !ifend
 !let !vrs2= !vars2
 !do !var1 !in (!vars1) !let !var2= !head(!vrs2) !let !vrs2= !tail(!vrs2)
- get var2 /vari= !var1 !var2 /miss= omit.
- comp var1= var2(:,1).
- comp var2= var2(:,2).
- print /title '------------'.
- print /title !quote(!conc('Пара V1 - V2: ',!var1,' - ',!var2)).
- comp ok= 1.
  !if (!values='AUTO') !then
-  comp vals1= design(var1).
-  comp vals2= design(var2).
-  comp tab= t(vals1)*vals2.
-  comp vals1= var1*make(1,ncol(vals1),1)&*vals1.
-  comp vals1= t(cmax(vals1)+cmin(vals1)).
-  comp vals2= var2*make(1,ncol(vals2),1)&*vals2.
-  comp vals2= cmax(vals2)+cmin(vals2).
-  comp @rgrd= grade(vals1).
-  comp @cgrd= grade(vals2).
-  comp tab(@rgrd,@cgrd)= tab.
-  comp vals1(@rgrd)= vals1.
-  comp vals2(@cgrd)= vals2.
-  do if nrow(tab)<>ncol(tab).
-   comp ok= 0.
-   print /title '>ERROR. Кросс-таблица не квадратна.'.
-  else if any(vals1<>t(vals2)).
-   comp ok= 0.
-   print /title '>ERROR. Значения переменных не совпадают.'.
-  else.
-   comp vals= vals2.
-  end if.
  !else
-  comp tab= make(nrow(var1),1,1).
-  comp tab= (t(var1)(make(ncol(vals),1,1),:)=t(vals)*t(tab))*(var2*make(1,ncol(vals),1)=vals(tab,:)).
-  do if not all(rsum(tab)+t(csum(tab))).
-   comp ok= 0.
-   print /title '>ERROR. Некоторые VALUES отсутствуют в обеих переменных.'.
-  end if.
  !ifend
- do if all(diag(tab)=rsum(tab)).
-  print /title '>ERROR. Данные в обеих переменных полностью совпадают.'.
-  comp ok= 0.
- end if.
- do if ok.
   !if (!print='YES') !then
-   print {9999,vals;t(vals),tab} /title 'Кросстабуляция (значения - 1-й столбец и 1-й ряд):'.
   !ifend
-  comp rt= rsum(tab).
-  comp ct= csum(tab).
-  comp n= msum(rt).
-  comp k= ncol(tab).
   !if (!level='INT') !then
-   comp mean1= msum(vals&*t(rt))/n.
-   comp mean2= msum(vals&*ct)/n.
-   comp se= vals(make(1,k,1),:).
-   comp se= (t(se)-se).
-   comp se= sqrt(msum(se&*se&*tab/n)/n).
-   comp dif= mean2-mean1.
-   comp z= dif/se.
-   comp sig1= 1-cdfnorm(abs(z)).
-   comp sig2= 2*sig1.
-   print {n,dif,se,z,sig1,sig2} /title ' ' /clab= 'N' 'MeanDif' 'StdError' 'Z' 'Sig1side' 'Sig2side' /format= f8.4.
    !if (!save='YES') !then
-    comp sav= {sav;n,dif,se,z,sig1,sig2}.
    !ifend
   !else !if (!level='ORD') !then
-   comp rt= rt/n.
-   comp ct= ct/n.
-   comp tab= tab/n.
-   comp rcum= rt.
-   comp ccum= ct.
-   loop i= 2 to k.
-    comp rcum(i)= rcum(i-1)+rcum(i).
-    comp ccum(i)= ccum(i-1)+ccum(i).
-   end loop.
-   comp ra= rt/2.
-   comp ca= ct/2.
-   loop i= 2 to k.
-    comp ra(i)= rcum(i-1)+ra(i).
-    comp ca(i)= ccum(i-1)+ca(i).
-   end loop.
-   comp ract= ct*ra.
-   comp cart= ca*rt.
-   comp phi= 2*(ra*make(1,k,1)-ca(make(1,k,1),:)).
-   comp se= phi&*tab.
-   comp se= sqrt((msum(phi&*se)-msum(se)&**2)/n).
-   comp dif= ract-cart.
-   comp z= dif/se.
-   comp sig1= 1-cdfnorm(abs(z)).
-   comp sig2= 2*sig1.
-   print {n,dif,se,z,sig1,sig2} /title ' ' /clab= 'N' 'StochDif' 'StdError' 'Z' 'Sig1side' 'Sig2side' /format= f8.4.
    !if (!save='YES') !then
-    comp sav= {sav;n,dif,se,z,sig1,sig2}.
    !ifend
   !else
-   comp dg= diag(tab).
-   comp dgeqm= dg=rt and dg=t(ct).
-   do if any(dgeqm).
-    comp keep= make(1,k-msum(dgeqm),0).
-    comp cnt= 0.
-    loop i= 1 to k.
-     do if not dgeqm(i).
-      comp cnt= cnt+1.
-      comp keep(cnt)= i.
-     end if.
-    end loop.
-    comp tab= tab(keep,keep).
-    comp rt= rt(keep).
-    comp ct= ct(keep).
-   end if.
-   comp k_1= ncol(tab)-1.
-   comp d= (rt-t(ct))(1:k_1).
-   comp s= -(tab(1:k_1,1:k_1)+t(tab(1:k_1,1:k_1))).
-   loop i= 1 to k_1.
-    comp s(i,i)= rt(i)+ct(i)-2*tab(i,i).
-   end loop.
-   comp chi2= t(d)*inv(s)*d.
-   comp chi2_= chi2/(1-chi2/n).
-   comp df= k-1.
-   comp sig= 1-chicdf(chi2,df).
-   comp sig_= 1-chicdf(chi2_,df).
-   print {chi2,sig;chi2_,sig_} /title ' ' /rlab= 'StuMaxw' 'Bhapkar' /clab= 'Chi-sq' 'Sig.' /format= f8.4.
-   print {df;n} /title ' ' /rlab= 'df=' 'N=' /space= 0.
    !if (!save='YES') !then
-    comp sav= {sav;n,df,chi2,sig,chi2_,sig_}.
    !ifend
   !ifend !ifend
- else.
-  print /title '>Тест не будет проделан для данной пары переменных.' /space= 0.
  !if (!save='YES') !then
-  comp sav= {sav;make(1,6,-999)}.
  !ifend
- end if.
 !doend
 !if (!save='YES') !then
- save sav(2:nrow(sav),:) /out= * /vari= 
    !if (!level='INT') !then N MeanDif StdError Z Sig1 Sig2
    !else !if (!level='ORD') !then N StochDif StdError Z Sig1 Sig2
    !else N df SM_ChiSq SM_Sig B_ChiSq B_Sig
    !ifend !ifend.
 !ifend
end matrix.
!else
-echo '>!KO_MHTESTS не выполнен.'.
!ifend
!enddefine.
